diff --exclude=CVS -Nru certi/libRTI/HandleSets.cc certi.new/libRTI/HandleSets.cc
--- certi/libRTI/HandleSets.cc	1970-01-01 01:00:00.000000000 +0100
+++ certi.new/libRTI/HandleSets.cc	2008-12-05 17:05:19.000000000 +0100
@@ -0,0 +1,540 @@
+// ----------------------------------------------------------------------------
+// CERTI - HLA RunTime Infrastructure
+// Copyright (C) 2002-2006  ONERA
+//
+// This program is free software ; you can redistribute it and/or
+// modify it under the terms of the GNU Lesser General Public License
+// as published by the Free Software Foundation ; either version 2 of
+// the License, or (at your option) any later version.
+//
+// This program is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY ; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+// Lesser General Public License for more details.
+//
+// You should have received a copy of the GNU Lesser General Public
+// License along with this program ; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+// ----------------------------------------------------------------------------
+
+#include "certi.hh"
+
+#include "HandleSets.hh"
+#include "GAV.hh"
+#include "PrettyDebug.hh"
+
+#include <algorithm>
+#include <string.h>
+
+using namespace certi ;
+
+namespace {
+
+static PrettyDebug D("LIBRTI", __FILE__);
+static PrettyDebug G("GENDOC",__FILE__);
+
+}
+
+// ----------------------------------------------------------------------------
+AttributeHandleValuePairSetImp::AttributeHandleValuePairSetImp(ULong size)
+{
+    _order = RECEIVE;
+    _transport = RELIABLE;
+
+    std::vector<AttributeHandleValuePair_t>::reserve(size);
+}
+
+AttributeHandleValuePairSetImp::AttributeHandleValuePairSetImp(const std::vector<AttributeHandleValuePair_t> &val)
+    : std::vector<AttributeHandleValuePair_t>(val)
+{
+    _order = RECEIVE;
+    _transport = RELIABLE;
+}
+
+AttributeHandleValuePairSetImp::~AttributeHandleValuePairSetImp()
+{
+}
+
+ULong AttributeHandleValuePairSetImp::size() const
+{
+    return std::vector<AttributeHandleValuePair_t>::size();
+}
+
+Handle AttributeHandleValuePairSetImp::getHandle(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i).first;
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+ULong AttributeHandleValuePairSetImp::getValueLength(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i).second.size();
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void AttributeHandleValuePairSetImp::getValue(ULong i, char *buff, ULong &len) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size()) {
+        const AttributeHandleValuePair_t& item = operator[](i);
+        len = item.second.size();
+        memcpy(buff, item.second.data(), len);
+    }
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+char *AttributeHandleValuePairSetImp::getValuePointer(ULong i, ULong &len) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size()) {
+        const AttributeHandleValuePair_t& item = operator[](i);
+        len = item.second.size();
+        return (char *)item.second.data();
+    }
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+TransportType AttributeHandleValuePairSetImp::getTransportType(ULong) const
+    throw (RTI::InvalidHandleValuePairSetContext)
+{
+    return _transport;
+}
+
+OrderType AttributeHandleValuePairSetImp::getOrderType(ULong) const
+    throw (RTI::ArrayIndexOutOfBounds, RTI::InvalidHandleValuePairSetContext)
+{
+    return _order;
+}
+
+RTI::Region *AttributeHandleValuePairSetImp::getRegion(ULong) const
+    throw (RTI::ArrayIndexOutOfBounds, RTI::InvalidHandleValuePairSetContext)
+{
+    throw RTI::RTIinternalError("unimplemented function getRegion()");
+}
+
+void AttributeHandleValuePairSetImp::add(Handle h, const char *str, ULong len)
+    throw (RTI::ValueLengthExceeded, RTI::ValueCountExceeded)
+{
+    push_back(AttributeHandleValuePair_t(h, std::string(str, len)));
+}
+
+void AttributeHandleValuePairSetImp::remove(Handle h)
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    for (iterator pos = begin(); pos != end(); pos++) {
+        if (pos->first == h) {
+            std::vector<AttributeHandleValuePair_t>::erase(pos);
+            return;
+        }
+    }
+
+    throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void AttributeHandleValuePairSetImp::moveFrom(const AttributeHandleValuePairSet &, ULong &)
+    throw (RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds)
+{
+    throw RTI::RTIinternalError("unimplemented function moveFrom()");
+}
+
+void AttributeHandleValuePairSetImp::empty()
+{
+    std::vector<AttributeHandleValuePair_t>::clear();
+}
+
+ULong AttributeHandleValuePairSetImp::start() const
+{
+    // not implemented
+    return 0 ;
+}
+
+ULong AttributeHandleValuePairSetImp::valid(ULong i) const
+{
+    // not implemented
+    return 0 ;
+}
+
+ULong AttributeHandleValuePairSetImp::next(ULong i) const
+{
+    // not implemented
+    return 0 ;
+}
+
+const std::vector<AttributeHandleValuePair_t>&
+AttributeHandleValuePairSetImp::getAttributeHandleValuePairs() const
+{
+    return *this;
+}
+
+// ----------------------------------------------------------------------------
+AttributeHandleSetImp::AttributeHandleSetImp(ULong size)
+{
+    std::vector<AttributeHandle>::reserve(size);
+}
+
+AttributeHandleSetImp::AttributeHandleSetImp(const std::vector<AttributeHandle> &val)
+    : std::vector<AttributeHandle>(val)
+{
+}
+
+AttributeHandleSetImp::~AttributeHandleSetImp()
+{
+}
+
+ULong AttributeHandleSetImp::size() const
+{
+    return std::vector<AttributeHandle>::size();
+}
+
+AttributeHandle AttributeHandleSetImp::getHandle(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i);
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void AttributeHandleSetImp::add(AttributeHandle h)
+    throw (RTI::ArrayIndexOutOfBounds, RTI::AttributeNotDefined)
+{
+    std::vector<AttributeHandle>::push_back(h);
+}
+
+void AttributeHandleSetImp::remove(AttributeHandle h)
+    throw (RTI::AttributeNotDefined)
+{
+    iterator pos = std::find(begin(), end(), h);
+    if (pos != end())
+        std::vector<AttributeHandle>::erase(pos);
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void AttributeHandleSetImp::empty()
+{
+    std::vector<AttributeHandle>::clear();
+}
+
+RTI::Boolean AttributeHandleSetImp::isEmpty() const
+{
+    return RTI::Boolean(std::vector<AttributeHandle>::empty());
+}
+
+RTI::Boolean AttributeHandleSetImp::isMember(AttributeHandle h) const
+{
+    return RTI::Boolean(std::find(begin(), end(), h) != end());
+}
+
+const std::vector<AttributeHandle>&
+AttributeHandleSetImp::getAttributeHandles() const
+{
+    return *this;
+}
+
+// ----------------------------------------------------------------------------
+FederateHandleSetImp::FederateHandleSetImp(ULong size)
+{
+    std::vector<FederateHandle>::reserve(size);
+}
+
+FederateHandleSetImp::~FederateHandleSetImp()
+{
+}
+
+ULong FederateHandleSetImp::size() const
+{
+    return std::vector<FederateHandle>::size();
+}
+
+FederateHandle FederateHandleSetImp::getHandle(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i);
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void FederateHandleSetImp::add(FederateHandle h)
+    throw (RTI::ValueCountExceeded)
+{
+    std::vector<FederateHandle>::push_back(h);
+}
+
+void FederateHandleSetImp::remove(FederateHandle h)
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    iterator pos = std::find(begin(), end(), h);
+    if (pos != end())
+        std::vector<FederateHandle>::erase(pos);
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void FederateHandleSetImp::empty()
+{
+    std::vector<AttributeHandle>::clear();
+}
+
+RTI::Boolean FederateHandleSetImp::isMember(FederateHandle h) const
+{
+    return RTI::Boolean(std::find(begin(), end(), h) != end());
+}
+
+// ----------------------------------------------------------------------------
+ParameterHandleValuePairSetImp::ParameterHandleValuePairSetImp(ULong size)
+{
+    _order = RECEIVE;
+    _transport = RELIABLE;
+
+    std::vector<ParameterHandleValuePair_t>::reserve(size);
+}
+
+ParameterHandleValuePairSetImp::ParameterHandleValuePairSetImp(const std::vector<ParameterHandleValuePair_t> &val)
+    : std::vector<ParameterHandleValuePair_t>(val)
+{
+    _order = RECEIVE;
+    _transport = RELIABLE;
+}
+
+ParameterHandleValuePairSetImp::~ParameterHandleValuePairSetImp()
+{
+}
+
+ULong ParameterHandleValuePairSetImp::size() const
+{
+    return std::vector<ParameterHandleValuePair_t>::size();
+}
+
+Handle ParameterHandleValuePairSetImp::getHandle(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i).first;
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+ULong ParameterHandleValuePairSetImp::getValueLength(ULong i) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size())
+        return operator[](i).second.size();
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void ParameterHandleValuePairSetImp::getValue(ULong i, char *buff, ULong &len) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size()) {
+        const ParameterHandleValuePair_t& item = operator[](i);
+        len = item.second.size();
+        memcpy(buff, item.second.data(), len);
+    }
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+char *ParameterHandleValuePairSetImp::getValuePointer(ULong i, ULong &len) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (i < size()) {
+        const ParameterHandleValuePair_t& item = operator[](i);
+        len = item.second.size();
+        return (char *)item.second.data();
+    }
+    else
+        throw RTI::ArrayIndexOutOfBounds("");
+}
+
+TransportType ParameterHandleValuePairSetImp::getTransportType() const
+    throw (RTI::InvalidHandleValuePairSetContext)
+{
+    return _transport;
+}
+
+OrderType ParameterHandleValuePairSetImp::getOrderType() const
+    throw (RTI::InvalidHandleValuePairSetContext)
+{
+    return _order;
+}
+
+RTI::Region *ParameterHandleValuePairSetImp::getRegion() const
+    throw (RTI::InvalidHandleValuePairSetContext)
+{
+    throw RTI::RTIinternalError("unimplemented function getRegion()");
+}
+
+void ParameterHandleValuePairSetImp::add(Handle h, const char *str, ULong len)
+    throw (RTI::ValueLengthExceeded, RTI::ValueCountExceeded)
+{
+    push_back(ParameterHandleValuePair_t(h, std::string(str, len)));
+}
+
+void ParameterHandleValuePairSetImp::remove(Handle h)
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    for (iterator pos = begin(); pos != end(); pos++) {
+        if (pos->first == h) {
+            std::vector<ParameterHandleValuePair_t>::erase(pos);
+            return;
+        }
+    }
+
+    throw RTI::ArrayIndexOutOfBounds("");
+}
+
+void ParameterHandleValuePairSetImp::moveFrom(const ParameterHandleValuePairSet &, ULong &)
+    throw (RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds)
+{
+    throw RTI::RTIinternalError("unimplemented function moveFrom()");
+}
+
+void ParameterHandleValuePairSetImp::empty()
+{
+    return std::vector<ParameterHandleValuePair_t>::clear();
+}
+
+ULong ParameterHandleValuePairSetImp::start() const
+{
+    // not implemented
+    return 0;
+}
+
+ULong ParameterHandleValuePairSetImp::valid(ULong i) const
+{
+    // not implemented
+    return 0;
+}
+
+ULong ParameterHandleValuePairSetImp::next(ULong i) const
+{
+    // not implemented
+    return 0;
+}
+
+const std::vector<ParameterHandleValuePair_t> &
+ParameterHandleValuePairSetImp::getParameterHandleValuePairs() const
+{
+    return *this;
+}
+
+// ----------------------------------------------------------------------------
+RTI::AttributeHandleValuePairSet *
+RTI::AttributeSetFactory::create(ULong size)
+    throw (MemoryExhausted, ValueCountExceeded, HandleValuePairMaximumExceeded)
+{
+    return new AttributeHandleValuePairSetImp(size);
+}
+
+// ----------------------------------------------------------------------------
+RTI::AttributeHandleSet *
+RTI::AttributeHandleSetFactory::create(ULong size)
+    throw (MemoryExhausted, ValueCountExceeded)
+{
+    return new AttributeHandleSetImp(size);
+}
+
+// ----------------------------------------------------------------------------
+RTI::FederateHandleSet *
+RTI::FederateHandleSetFactory::create(ULong size)
+    throw (MemoryExhausted, ValueCountExceeded)
+{
+    return new FederateHandleSetImp(size);
+}
+
+// ----------------------------------------------------------------------------
+RTI::ParameterHandleValuePairSet *
+RTI::ParameterSetFactory::create(ULong size)
+    throw (MemoryExhausted, ValueCountExceeded, HandleValuePairMaximumExceeded)
+{
+    return new ParameterHandleValuePairSetImp(size);
+}
+
+// ----------------------------------------------------------------------------
+RegionImp::RegionImp(RegionHandle h, SpaceHandle s, const std::vector<Extent> &ext)
+    : handle(h), space(s), coExtents(ext)
+{
+}
+
+RegionImp::~RegionImp()
+{
+}
+
+ULong RegionImp::getRangeLowerBound(ExtentIndex index, DimensionHandle dimension) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < extents.size())
+        return extents[index].getRangeLowerBound(dimension);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+ULong RegionImp::getRangeUpperBound(ExtentIndex index, DimensionHandle dimension) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < extents.size())
+        return extents[index].getRangeUpperBound(dimension);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+void RegionImp::setRangeLowerBound(ExtentIndex index, DimensionHandle dimension, ULong val)
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < extents.size())
+        extents[index].setRangeLowerBound(dimension, val);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+void RegionImp::setRangeUpperBound(ExtentIndex index, DimensionHandle dimension, ULong val)
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < extents.size())
+        extents[index].setRangeUpperBound(dimension, val);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+SpaceHandle RegionImp::getSpaceHandle() const
+    throw ()
+{
+    return space;
+}
+
+ULong RegionImp::getNumberOfExtents() const
+    throw ()
+{
+    return coExtents.size();
+}
+
+ULong RegionImp::getRangeLowerBoundNotificationLimit(ExtentIndex index, DimensionHandle dimension) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < coExtents.size())
+        return coExtents[index].getRangeLowerBound(dimension);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+ULong RegionImp::getRangeUpperBoundNotificationLimit(ExtentIndex index, DimensionHandle dimension) const
+    throw (RTI::ArrayIndexOutOfBounds)
+{
+    if (index < coExtents.size())
+        return coExtents[index].getRangeUpperBound(dimension);
+    else
+        throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
+}
+
+// $Id: RTItypes.cc,v 1.1 2008/11/25 16:32:14 gotthardp Exp $
diff --exclude=CVS -Nru certi/libRTI/HandleSets.hh certi.new/libRTI/HandleSets.hh
--- certi/libRTI/HandleSets.hh	1970-01-01 01:00:00.000000000 +0100
+++ certi.new/libRTI/HandleSets.hh	2008-12-05 17:06:13.000000000 +0100
@@ -0,0 +1,233 @@
+// HLA 1.3 Header "RTItypes.hh"
+// $Id: RTItypes.hh,v 3.18 2007/09/25 13:42:54 erk Exp $
+
+#ifndef _RTI_HANDLESETS_HH
+#define _RTI_HANDLESETS_HH
+
+#include "certi.hh"
+#include "Extent.hh"
+
+namespace certi {
+
+template<class I>
+struct cast
+{
+    template<class R>
+    const I& operator()(const R& imp)
+    {
+        try {
+            return dynamic_cast<const I&>(imp);
+        }
+        catch (...)
+        {
+            throw RTI::RTIinternalError("Incompatible object on input.");
+        }
+    }
+};
+
+typedef std::pair<AttributeHandle, AttributeValue_t> AttributeHandleValuePair_t;
+
+class RTI_EXPORT AttributeHandleValuePairSetImp
+    : public RTI::AttributeHandleValuePairSet, protected std::vector<AttributeHandleValuePair_t>
+{
+public:
+    AttributeHandleValuePairSetImp(ULong);
+    AttributeHandleValuePairSetImp(const std::vector<AttributeHandleValuePair_t> &);
+
+    virtual ~AttributeHandleValuePairSetImp();
+
+    virtual ULong size() const;
+
+    virtual Handle getHandle(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual ULong getValueLength(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void getValue(ULong, char *, ULong &) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual char *getValuePointer(ULong, ULong &) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual TransportType getTransportType(ULong) const
+        throw (RTI::InvalidHandleValuePairSetContext);
+
+    virtual OrderType getOrderType(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds, RTI::InvalidHandleValuePairSetContext);
+
+    virtual RTI::Region *getRegion(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds, RTI::InvalidHandleValuePairSetContext);
+
+    virtual void add(Handle, const char *, ULong)
+        throw (RTI::ValueLengthExceeded, RTI::ValueCountExceeded);
+
+    virtual void remove(Handle h)
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void moveFrom(const AttributeHandleValuePairSet &, ULong &)
+        throw (RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds);
+
+    virtual void empty();
+
+    virtual ULong start() const;
+    virtual ULong valid(ULong i) const;
+    virtual ULong next(ULong i) const;
+
+    const std::vector<AttributeHandleValuePair_t>& getAttributeHandleValuePairs() const;
+
+protected:
+    OrderType _order ;
+    TransportType _transport ;
+};
+
+class RTI_EXPORT AttributeHandleSetImp
+    : public RTI::AttributeHandleSet, protected std::vector<AttributeHandle>
+{
+public:
+    AttributeHandleSetImp(ULong);
+    AttributeHandleSetImp(const std::vector<AttributeHandle> &);
+
+    virtual ~AttributeHandleSetImp();
+
+    virtual ULong size() const;
+
+    virtual AttributeHandle getHandle(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void add(AttributeHandle)
+        throw (RTI::ArrayIndexOutOfBounds, RTI::AttributeNotDefined);
+
+    virtual void remove(AttributeHandle)
+        throw (RTI::AttributeNotDefined);
+
+    virtual void empty();
+
+    virtual RTI::Boolean isEmpty() const;
+    virtual RTI::Boolean isMember(AttributeHandle h) const;
+
+    const std::vector<AttributeHandle>& getAttributeHandles() const;
+};
+
+class RTI_EXPORT FederateHandleSetImp
+    : public RTI::FederateHandleSet, protected std::vector<FederateHandle>
+{
+public:
+    FederateHandleSetImp(ULong);
+    virtual ~FederateHandleSetImp();
+
+    virtual ULong size() const;
+
+    virtual FederateHandle getHandle(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void add(FederateHandle)
+        throw (RTI::ValueCountExceeded);
+
+    virtual void remove(FederateHandle)
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void empty();
+
+    virtual RTI::Boolean isMember(FederateHandle) const;
+};
+
+typedef std::pair<ParameterHandle, ParameterValue_t> ParameterHandleValuePair_t;
+
+class RTI_EXPORT ParameterHandleValuePairSetImp
+    : public RTI::ParameterHandleValuePairSet, protected std::vector<ParameterHandleValuePair_t>
+{
+public:
+    ParameterHandleValuePairSetImp(ULong);
+    ParameterHandleValuePairSetImp(const std::vector<ParameterHandleValuePair_t> &);
+    virtual ~ParameterHandleValuePairSetImp();
+
+    virtual ULong size() const;
+
+    virtual Handle getHandle(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual ULong getValueLength(ULong) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void getValue(ULong, char *, ULong &) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual char *getValuePointer(ULong, ULong &) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual TransportType getTransportType() const
+        throw (RTI::InvalidHandleValuePairSetContext);
+
+    virtual OrderType getOrderType() const
+        throw (RTI::InvalidHandleValuePairSetContext);
+
+    virtual RTI::Region *getRegion() const
+        throw (RTI::InvalidHandleValuePairSetContext);
+
+    virtual void add(Handle, const char *, ULong)
+        throw (RTI::ValueLengthExceeded, RTI::ValueCountExceeded);
+
+    virtual void remove(Handle)
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void moveFrom(const ParameterHandleValuePairSet &, ULong &)
+        throw (RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds);
+
+    virtual void empty();
+
+    virtual ULong start() const;
+    virtual ULong valid(ULong i) const;
+    virtual ULong next(ULong i) const;
+
+    const std::vector<ParameterHandleValuePair_t>& getParameterHandleValuePairs() const;
+
+protected:
+    OrderType _order ;
+    TransportType _transport ;
+};
+
+
+class RTI_EXPORT RegionImp : public RTI::Region
+{
+public:
+    RegionImp(RegionHandle, SpaceHandle, const std::vector<Extent> &);
+    virtual ~RegionImp();
+
+    virtual ULong getRangeLowerBound(ExtentIndex, DimensionHandle) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual ULong getRangeUpperBound(ExtentIndex, DimensionHandle) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void setRangeLowerBound(ExtentIndex, DimensionHandle, ULong)
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual void setRangeUpperBound(ExtentIndex, DimensionHandle, ULong)
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual SpaceHandle getSpaceHandle() const
+        throw ();
+
+    virtual ULong getNumberOfExtents() const
+        throw ();
+
+    virtual ULong getRangeLowerBoundNotificationLimit(ExtentIndex, DimensionHandle) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+    virtual ULong getRangeUpperBoundNotificationLimit(ExtentIndex, DimensionHandle) const
+        throw (RTI::ArrayIndexOutOfBounds);
+
+private:
+    RegionHandle handle;
+    SpaceHandle space;
+    std::vector<Extent> extents;
+
+    std::vector<Extent> coExtents;
+};
+
+}
+
+#endif // _RTI_HANDLESETS_HH
+
+// $Id: RTItypes.hh,v 3.18 2007/09/25 13:42:54 erk Exp $
